unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, DXDraws, jpeg, map_data, ExtCtrls, AppEvnts, StdCtrls;

const
  _DEF_IP = '192.168.2.76';
  _DEF_PORT = 80;
  _POINT_SIZE = 256;    //in px

type
  TF_Main = class(TForm)
    MM_Main: TMainMenu;
    MI_Server: TMenuItem;
    MI_Zaklad: TMenuItem;
    DXD_Main: TDXDraw;
    MI_Debug: TMenuItem;
    AE_Main: TApplicationEvents;
    Label1: TLabel;
    Label2: TLabel;
    L_Zoom: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure MI_ServerClick(Sender: TObject);
    procedure MI_ZakladClick(Sender: TObject);
    procedure MI_DebugClick(Sender: TObject);
    procedure AE_MainMessage(var Msg: tagMSG; var Handled: Boolean);
  private
    { Private declarations }
  public
    serverip:string;
    serverport:SmallInt;
    CurrentPos:TPoint;      //center pos in px

    procedure getImg(data:TJpegImage;pos:TXYZPoint);
    procedure renderPoint(data:TJpegImage;pos:TXYZPoint);
  end;

var
  F_Main: TF_Main;

implementation

uses fServerOptions, fZaklad, fDebug;

{$R *.dfm}

//keys event case
procedure TF_Main.AE_MainMessage(var Msg: tagMSG;
  var Handled: Boolean);
var tmp:TCanvas;
begin
 if (msg.message = WM_KEYDOWN) then
  begin
    case (msg.wParam) of
     //case key
     Integer('D'):begin
          //white color
          Self.DXD_Main.Surface.Fill(clWhite);
          F_Main.DXD_Main.Surface.Canvas.Release;
          F_Main.DXD_Main.Flip;

          //zoom
          AllMap.zoom();
          AllMap.getPoint(Point(Self.CurrentPos.X*2 div _POINT_SIZE, Self.CurrentPos.Y*2 div _POINT_SIZE));
          Self.CurrentPos.X := Self.CurrentPos.X*2;
          Self.CurrentPos.Y := Self.CurrentPos.Y*2;
          F_Main.L_Zoom.Caption := IntToStr(AllMap.z);
       end;
     Integer('S'):begin
          //white color
          Self.DXD_Main.Surface.Fill(clWhite);
          F_Main.DXD_Main.Surface.Canvas.Release;
          F_Main.DXD_Main.Flip;

          //dezoom
          AllMap.dezoom();
          AllMap.getPoint(Point(Self.CurrentPos.X div 2 div _POINT_SIZE, Self.CurrentPos.Y div 2 div _POINT_SIZE));
          Self.CurrentPos.X := Self.CurrentPos.X div 2;
          Self.CurrentPos.Y := Self.CurrentPos.Y div 2;
          F_Main.L_Zoom.Caption := IntToStr(AllMap.z);
       end;

      VK_UP:begin
          //move up
          AllMap.getPoint(Point(Self.CurrentPos.X div _POINT_SIZE, Self.CurrentPos.Y div _POINT_SIZE - 1));

          Self.CurrentPos.X := Self.CurrentPos.X;
          Self.CurrentPos.Y := Self.CurrentPos.Y - _POINT_SIZE;
      end;

      VK_DOWN:begin
          //move down
          AllMap.getPoint(Point(Self.CurrentPos.X div _POINT_SIZE, Self.CurrentPos.Y div _POINT_SIZE + 1));

          Self.CurrentPos.X := Self.CurrentPos.X;
          Self.CurrentPos.Y := Self.CurrentPos.Y + _POINT_SIZE;
      end;

      VK_LEFT:begin
          //move left
          AllMap.getPoint(Point(Self.CurrentPos.X div _POINT_SIZE - 1, Self.CurrentPos.Y div _POINT_SIZE));

          Self.CurrentPos.X := Self.CurrentPos.X - _POINT_SIZE;
          Self.CurrentPos.Y := Self.CurrentPos.Y;
      end;

      VK_RIGHT:begin
          //move right
          AllMap.getPoint(Point(Self.CurrentPos.X div _POINT_SIZE + 1, Self.CurrentPos.Y div _POINT_SIZE));

          Self.CurrentPos.X := Self.CurrentPos.X + _POINT_SIZE;
          Self.CurrentPos.Y := Self.CurrentPos.Y;
      end;

    end;//case key
  end;//if msg. message = ...
end;

procedure TF_Main.FormCreate(Sender: TObject);
begin
 Self.serverip   := _DEF_IP;
 Self.serverport := _DEF_PORT;
end;//procedure

procedure TF_Main.MI_DebugClick(Sender: TObject);
begin
 F_Debug.Show();
end;

procedure TF_Main.MI_ServerClick(Sender: TObject);
begin
 F_Server.ShowModal();
end;

procedure TF_Main.MI_ZakladClick(Sender: TObject);
begin
 F_Zaklad.ShowModal();
end;//procedure

//when one map element is get from AllMap
procedure TF_Main.getImg(data:TJpegImage;pos:TXYZPoint);
begin
 Self.renderPoint(data, pos);
end;//procedure

//show one map element
procedure TF_Main.renderPoint(data:TJpegImage;pos:TXYZPoint);
var Bitmap:TBitmap;
    grap:TGraphic;
begin
 Bitmap := TBitmap.Create;    //create temp bitmap
  try
   Bitmap.Assign(data);     //assign jpeg image to the bitmap

   //paint bitmap
   Self.DXD_Main.Surface.Canvas.CopyRect(Rect((pos.X+1)*_POINT_SIZE - Self.CurrentPos.X, (pos.Y+1)*_POINT_SIZE - Self.CurrentPos.Y, ((pos.X+1)*_POINT_SIZE)+_POINT_SIZE - Self.CurrentPos.X, + ((Pos.Y+1)*_POINT_SIZE)+_POINT_SIZE - Self.CurrentPos.Y), bitmap.Canvas, Rect(0, 0, _POINT_SIZE, _POINT_SIZE));
  finally
    FreeAndNil(Bitmap);

    //update the canvas
    Self.DXD_Main.Surface.Canvas.Release;
    Self.DXD_Main.Flip;
  end;
end;//procedure

end.//unit
