unit mapThread;

interface

uses
  Classes, map_data, jpeg, IDHttp, main, SysUtils;

type
  TMapThread = class(TThread)
  private
    pos:TXYZPoint;

  protected
    procedure Execute; override;

  public
    constructor Create(pos:TXYZPoint);
  end;

implementation

uses fDebug;

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TMapThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TMapThread }

procedure TMapThread.Execute;
var
  MS : TMemoryStream;
  jpg: TJpegImage;
  client: TIdHTTP;
begin
 Self.Terminate;

 MS := TMemoryStream.Create;
 jpg := TJPEGImage.Create;
 client := TIdHTTP.Create(nil);

 try
    //get map from a server
    client.get('http://'+F_Main.serverip+':'+IntToStr(F_Main.serverport)+'/'+IntToStr(self.pos.Z)+'/'+IntToStr(Self.pos.X)+'/'+IntToStr(Self.pos.Y)+'.jpg', MS);
    MS.Seek(0,soFromBeginning);
    jpg.LoadFromStream(MS);

  finally
    //wait for TAllMap to be ready
    while (not AllMap.get_ready) do sleep(10);
    
    AllMap.onGetMapPoint(jpg, Self.pos);
    FreeAndNil(jpg);
    FreeAndNil(MS);
  end;
end;

constructor TMapThread.Create(pos:TXYZPoint);
begin
 inherited Create(false);

 Self.pos := pos;
end;//ctor

end.
